/*
    Scanbot SDK Flutter Plugin

    Copyright (c) 2019 doo GmbH. All rights reserved.
 */
package io.scanbot.sdk.flutter

import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel

interface ISdkSubplugin {
    suspend fun onMethodCall(call: MethodCall, result: MethodChannel.Result): Boolean
}

interface ISdkSubpluginManager {
    val subplugins: MutableList<ISdkSubplugin>
    fun registerSubplugin(subplugin: ISdkSubplugin) {
        subplugins.add(subplugin)
    }

    suspend fun callMethod(call: MethodCall, result: MethodChannel.Result): Boolean {
        return subplugins.count { it.onMethodCall(call, result) }.takeIf { it > 0 }?.let { true }
            ?: false
    }

    fun clearPlugins() = subplugins.clear()
}

class SdkSubpluginManager : ISdkSubpluginManager {
    override val subplugins: MutableList<ISdkSubplugin> = mutableListOf()
}