import Flutter
import UIKit
import ScanbotSDK

public class SwiftScanbotSdkPlugin: NSObject, FlutterPlugin {
    
    private let callHandler = SDKCallHandler()
    
    public static func register(with registrar: FlutterPluginRegistrar) {
        let channel = FlutterMethodChannel(name: "scanbot_sdk", binaryMessenger: registrar.messenger())
        let instance = SwiftScanbotSdkPlugin()
        registrar.addMethodCallDelegate(instance, channel: channel)
    }
    
    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        let presenter = UIApplication.shared.windows.first?.rootViewController?.topViewController
        self.callHandler.handle(call: call, rootViewController: presenter, result: result)
    }
}
