import 'dart:ui';

import 'common_data.dart';

void addColor(Color color, String name, Map arguments) {
  if (color != null) arguments[name] = toColorString(color);
}

void addParam(dynamic argument, String name, Map arguments) {
  if (argument != null) arguments[name] = argument;
}

String toColorString(Color color) {
  return color != null ? '#${color.value.toRadixString(16)}' : null;
}

Color colorFromString(String color) {
  String valueString = color.replaceAll("#", "");
  int value = int.parse(valueString, radix: 16);
  return new Color(value);
}

Uri stringToFileUri(String string) {
  return Uri.parse(string);
}

String fileUriToString(Uri uri) {
  return uri.toString();
}

String imageFilterJsonValue(ImageFilterType filter) {
  return filter.toString().replaceFirst("ImageFilterType.", "");
}

const imageFormatMap = {ImageFormat.JPG: "JPG", ImageFormat.PNG: "PNG"};
